#ifndef LQMEAS_DEVICEVALIDATOR_H
#define LQMEAS_DEVICEVALIDATOR_H

#include "Device.h"
#include <QStringList>

namespace LQMeas {

    class DeviceValidator  {
    public:
        virtual bool deviceValid(QSharedPointer<Device> device) const = 0;
    };

    class DeviceNameValidator : public DeviceValidator {
    public:
        DeviceNameValidator(QStringList nameList) : m_devnames(nameList) {}

        bool deviceValid(QSharedPointer<Device> device) const {
            return device && (m_devnames.contains(device->name()) || m_devnames.empty());
        }

    private:
        QStringList m_devnames;
    };
}

#endif // LQMEAS_DEVICEVALIDATOR_H
