#include "e14_440.h"
#include "lcomp_headers.h"
#include "../../lqtdefs.h"

static double f_adc_ranges[] = {10, 2.5, 0.625,  0.156};

QString e14_440::modificationName() const {
    return m_dac_present ? name() + "D" : name();
}

QString e14_440::serial() const {
    return m_serial;
}


const double e14_440::adcRangeMaxVal(int range) const {
    return f_adc_ranges[range];
}

const double e14_440::adcRangeMinVal(int range) const {
    return -f_adc_ranges[range];
}




unsigned e14_440::adcRangesCnt() const {
    return sizeof(f_adc_ranges)/sizeof(f_adc_ranges[0]);
}

double e14_440::adcFreqMax() const {
    return 400000.;
}




LQMeasError e14_440::protConfigure() {
    return LQMeasError::Success();
}

LQMeasError e14_440::protFillDescr(const void *descr) {
    PLATA_DESCR_E440 *pd = (PLATA_DESCR_E440 *)descr;
    m_serial = QSTRING_FROM_CSTR(pd->SerNum);
    m_dac_present = pd->IsDacPresent != 0;
    return LQMeasError::Success();
}

e14_440::e14_440(IDaqLDevice *dev, const __SLOT_PARAM *par, unsigned slot) :
    lcompStreamDevice(dev, par, slot, LQMeasAdc::TypeSequential) {
}
