#ifndef E14_440_H
#define E14_440_H

#include "lcompStreamDevice.h"

class lcompResolver;



class e14_440: public lcompStreamDevice {
    Q_OBJECT
public:
    static QString typeDeviceName() {return "E14-440";}

    enum ChRange {
        CH_RANGE_10V    = 0,
        CH_RANGE_2_5V   = 1,
        CH_RANGE_0_625V = 2,
        CH_RANGE_0_156V = 3
    };


    QString name() const {return typeDeviceName();}
    QString modificationName() const;
    QString serial() const;
    DeviceInterface iface() const {return IFACE_USB;}
    QString firmwareName() {return "E440";}

    const double adcRangeMaxVal(int range) const;
    const double adcRangeMinVal(int range) const;
    unsigned adcRangesCnt() const;
    double adcFreqMax() const;
protected:
    LQMeasError protConfigure();

    LQMeasError protFillDescr(const void *descr);
private:
    explicit e14_440(IDaqLDevice *dev, const __SLOT_PARAM *par, unsigned slot);

    friend class lcompResolver;

    QString m_serial;
    bool m_dac_present;
};

#endif // E14_440_H
