#ifndef LCOMPDEVICE_H
#define LCOMPDEVICE_H

#include "../LQMeasDevice.h"
#include "lcompErrors.h"

struct __SLOT_PARAM;
struct IDaqLDevice;

class lcompDevice : public LQMeasDevice {
    Q_OBJECT
public:

    static QString firmwareDir();

    virtual QString firmwareName() { return QString(); }

    bool isOpened() const {return m_is_opened; }

    ~lcompDevice();

protected:
    LQMeasError protOpen();
    LQMeasError protClose();




    virtual LQMeasError protFillDescr(const void *descr) = 0;
    LQMeasError lcompDeviceStart();

    lcompDevice(IDaqLDevice *dev, const __SLOT_PARAM *par, unsigned slot);


    IDaqLDevice *m_dev;
private:
    bool m_is_opened;
    unsigned m_slot;
    unsigned m_board_type;

};

#endif // LCOMPDEVICE_H
