#ifndef LCOMPERRORS_H
#define LCOMPERRORS_H


#include "lqmeas/errs/LQMeasError.h"



class lcompErrors {
public:
    static LQMeasError CreateInstance()  {
        return LQMeasError(-1, QObject::tr("Ошибка создания экземпляра объекта"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError DeviceOpen()  {
        return LQMeasError(-2, QObject::tr("Не удалось отрыть устройство"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError LoadBios()  {
        return LQMeasError(-3, QObject::tr("Не удалось загрузить прошивку устройства"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError BoardTest()  {
        return LQMeasError(-4, QObject::tr("Ошибка тестирования платы"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError ReadBoardDescr()  {
        return LQMeasError(-5, QObject::tr("Ошибка чтения информации о плате"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError DeviceClose()  {
        return LQMeasError(-6, QObject::tr("Ошибка закрытия устройства"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError AdcFillParams()  {
        return LQMeasError(-7, QObject::tr("Ошибка заполнения параметров АЦП"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError AdcReqBuffer()  {
        return LQMeasError(-8, QObject::tr("Не удалось выделить буфер для приема данных"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError AdcSetParams()  {
        return LQMeasError(-9, QObject::tr("Ошибки установки параметров АЦП"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError AdcStartInit()  {
        return LQMeasError(-10, QObject::tr("Не удалось инициализировать запуск сбора данных"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError AdcStart()  {
        return LQMeasError(-11, QObject::tr("Не удалось запустить сбор данных"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError AdcStop()  {
        return LQMeasError(-12, QObject::tr("Не удалось остановить сбор данных"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
    static LQMeasError RecvBufOverflow()  {
        return LQMeasError(-13, QObject::tr("Переполнение буфера на прием данных"), LQMeasError::ERRTYPE_DEVNATIVE_LCOMP);
    }
};


#endif // LCOMPERRORS_H
