#ifndef LCOMPSTREAMRECEIVER_H
#define LCOMPSTREAMRECEIVER_H

#include <QThread>
#include <QMutex>
#include <QWaitCondition>
#include "lcompRecvProcessorIface.h"
#include "lcompErrors.h"

struct IDaqLDevice;
struct _DAQ_PARAM_;

class lcompStreamReceiver : public QThread {
    Q_OBJECT
public:
    explicit lcompStreamReceiver(QObject *parent = 0);

    LQMeasError setStreamParams(IDaqLDevice *idev, _DAQ_PARAM_ *sp, unsigned req_buf_size,
                                unsigned ch_cnt, unsigned StreamId);



    void dropData(unsigned size);

    void prestartInit();
    void stop();

    LQMeasError getData(lcompRecvProcessorIface *iproc, double *data, unsigned size, unsigned flags,
                        unsigned tout, unsigned *recvd_size);



protected:
    void run ();

private:


    unsigned m_driver_buf_size;
    unsigned m_point_size;
    unsigned m_ch_cnt;



    quint8 *m_driver_buf;
    volatile unsigned   *m_sync;
    quint8 *m_buf;
    unsigned m_buf_size;
    volatile unsigned m_buf_fill_size;
    unsigned m_buf_get_pos;

    volatile int m_stop_req;
    LQMeasError m_err;


    QMutex m_lock;
    QWaitCondition m_wait;

};

#endif // LCOMPSTREAMRECEIVER_H
