#ifndef LTRRESOLVER_H
#define LTRRESOLVER_H

#include <QList>
#include <QStringList>
#include <QSharedPointer>

#include "lqmeas/devs/resolver/LQDevResolver.h"

class LtrModule;
class LtrCrate;
class LQMeasDevice;
class LQMeasDeviceValidator;

class LtrResolver : public LQDevResolver {
public:
    QList<QSharedPointer<LtrModule> > getModuleList(QStringList nameFilter);
    QList<QSharedPointer<LtrModule> > getModuleList(const LQMeasDeviceValidator* validator);

    QList<QSharedPointer<LtrCrate> > getCratesList();

    QList<QSharedPointer<LQMeasDevice> > getDevList();

    static LtrResolver* resolver();

private:
    LtrResolver();
    QList< QSharedPointer<LtrCrate> > m_crates;

    QSharedPointer<LtrCrate> getCrate(QString serial);
    static QSharedPointer<LtrModule> createModule(QSharedPointer<LtrCrate> getCrate, unsigned slot, quint16 mid);

    friend class LtrCrate;
};

#endif // LTRRESOLVER_H
