#ifndef LTRMODULE_H
#define LTRMODULE_H


#include <QSharedPointer>

#include "lqmeas/devs/LQMeasDevice.h"
#include "lqmeas/devs/ltr/crates/LtrCrate.h"
#include "ltr/include/ltrapi.h"

class LtrResolver;
class LtrFrameReceiver;

class LtrModule : public LQMeasDevice {
    Q_OBJECT
public:

    ~LtrModule();

    unsigned mid() const;
    int slot() const;

    QSharedPointer<LtrCrate> crate() const {return m_crate;}


    LQMeasError error(int err) const;
protected:
    explicit LtrModule(QSharedPointer<LtrCrate> crate, unsigned slot, unsigned mid, QObject *parent = 0);


    virtual QString errorString(int err) const;
    virtual TLTR* channel() const=0;

    virtual LQMeasError rawWordsReceive(DWORD *wrds, unsigned size, unsigned tout, unsigned *recvd_size);
    virtual LQMeasError rawWordsSend(const DWORD *wrds, unsigned size, unsigned tout, unsigned *sent_size);
private:
    QSharedPointer<LtrCrate> m_crate;
    unsigned m_slot;
    unsigned m_mid;

    friend class LtrResolver;
    friend class LtrFrameReceiver;
};

#endif // LTRMODULE_H
