#include "DevicesResolver.h"
#include "lqmeas/devs/DeviceValidator.h"

namespace LQMeas {
    QList<QSharedPointer<Device> > DevicesResolver::getDevList(DeviceValidator *validator) {
        QList<QSharedPointer<Device> > devlist, retlist;
        devlist = getDevList();
        foreach (QSharedPointer<Device> dev, devlist) {
            if (dev && validator->deviceValid(dev))
                retlist.append(dev);
        }
        return retlist;
    }

    QList<QSharedPointer<Device> > DevicesResolver::getDevList(QStringList deviceNames) {
        QScopedPointer<DeviceValidator> val(new DeviceNameValidator(deviceNames));
        return getDevList(val.data());
    }
}
