#include "e502.h"
#include "e502api.h"

namespace LQMeas {
    QString E502::typeDeviceName() {
        return "E502";
    }

    QHostAddress E502::ipAddr() const {
        uint32_t addr;
        QHostAddress ret;
        Error err = error(E502_GetIpAddr(devHandle(), &addr));
        if (err.isSuccess()) {
            ret = QHostAddress(addr);
        }
        return ret;
    }

    QString E502::modificationName() const {
        QString retname = name() + QString("-%1-%2-%3").arg(m_devinfo.devflags & X502_DEVFLAGS_BF_PRESENT ? "P" : "X")
                .arg(m_devinfo.devflags & X502_DEVFLAGS_IFACE_SUPPORT_ETH ? "EU" : "U")
                .arg(m_devinfo.devflags & X502_DEVFLAGS_DAC_PRESENT ? "D" : "X");
        if (m_devinfo.devflags & X502_DEVFLAGS_INDUSTRIAL)
            retname += "-I";
        return retname;
    }

    E502::E502(const t_x502_devrec info) : X502(info) {

    }
}
