#ifndef LQMEAS_E502_H
#define LQMEAS_E502_H

#include "x502.h"
#include <QHostAddress>



namespace LQMeas {
    class x502Resolver;

    class E502 : public X502 {
        Q_OBJECT
    public:
        static QString typeDeviceName();

        QHostAddress ipAddr() const;

        QString modificationName() const;

        unsigned outGenSignalMaxSize() {return curOutRamChannels() == 0 ? 0 : 1.5*1024*1024/curOutRamChannels(); }
    private:
        explicit E502(const t_x502_devrec info);

        friend class x502Resolver;
    };
}
#endif // E502_H
