#ifndef LQMEAS_L502_H
#define LQMEAS_L502_H

#include "x502.h"
#include <QHostAddress>

class x502Resolver;

namespace LQMeas {
    class L502 : public X502 {
        Q_OBJECT
    public:
        static QString typeDeviceName();

        QString modificationName() const;

        unsigned outGenSignalMaxSize() {return curOutRamChannels() == 0 ? 0 : 150*1024*1024/curOutRamChannels(); }
    private:
        explicit L502(const t_x502_devrec info);

        friend class x502Resolver;
    };
}


#endif // LQMEAS_L502_H
