#ifndef LQMEAS_DEVOUTSTREAM_H
#define LQMEAS_DEVOUTSTREAM_H

#include "DevOut.h"
#include "DevOutStreamThread.h"

namespace LQMeas {
    class Device;

    class DevOutStream : public DevOut {
    public:
        Error outStreamInit(unsigned preload_points);
        Error outStreamStart();
        Error outStreamStop(unsigned tout=30000);


        virtual double outFreq() const = 0;

        bool outStreamIsRunning() const {return m_running;}
        Error outStreamError() const {return m_streamThread.error();}


        DevOutStreamThread* outStreamThread() {return &m_streamThread;}
    protected:
        DevOutStream(Device* dev);

        virtual Error protOutStreamInit() = 0;
        virtual Error protOutStreamStart() = 0;
        virtual Error protOutStreamStop(unsigned tout) = 0;
    private:
        bool m_running;

        DevOutStreamThread m_streamThread;
        Device *m_dev;


        friend class DevOutStreamThread;
    };
}

#endif // LQMEAS_DEVOUTSTREAM_H
