#include "DevOutStreamThread.h"
#include "DevOutStream.h"
#include "lqmeas/devs/Device.h"


namespace LQMeas {
    DevOutStreamThread::DevOutStreamThread(DevOutStream *dev) :
        QThread(), m_dev(dev) {
    }

    void DevOutStreamThread::run() {
        Error err = Error::Success();
        while (err.isSuccess() && !m_stop_req) {
            unsigned gen_points = 4096;
            QVector<double> dac_data;
            QVector<unsigned> dig_data;
            bool send_done = false;

            err = m_dev->outGenRamData(gen_points, dac_data, dig_data);

            if (err.isSuccess() && !m_stop_req && !send_done) {
                err = m_dev->protOutSendData(dac_data.data(), dac_data.size(),
                                         dig_data.data(), dig_data.size(),
                                         0, 3000);
                if (err == StdErrors::SendBusy()) {
                    err = Error::Success();
                } else if (err.isSuccess()) {
                    send_done = true;
                }
            }
        }

        m_err = err;
    }
}
