#ifndef LQMEAS_DEVOUTSTREAMTHREAD_H
#define LQMEAS_DEVOUTSTREAMTHREAD_H

#include <QThread>
#include "lqmeas/Error.h"


namespace LQMeas {

    class DevOutStream;

    class DevOutStreamThread : public QThread {
        Q_OBJECT
    public:
        explicit DevOutStreamThread(DevOutStream *dev);

        void init() {m_stop_req = false; m_err = Error::Success();}
        void setStopReq() {m_stop_req = true; }

        Error error() const {return m_err;}
    protected:
        void run();


    private:        
        bool m_stop_req;
        Error m_err;
        DevOutStream *m_dev;

    };
}

#endif // LQMEAS_DEVOUTSTREAMTHREAD_H
