#ifndef LQMEAS_LOGLEVEL_H
#define LQMEAS_LOGLEVEL_H

#include <QString>
#include <QColor>

namespace LQMeas {
    class LogLevel {
    public:
        enum Number {
            Invalid,
            FatalError,
            Error,
            Warning,
            Info,
            Detail,
            DebugHigh,
            DebugMedium,
            DebugLow
        } ;

        Number number() const {return m_lvl;}
        QColor color() const {return m_color;}
        QString name() const {return m_text;}


        const bool isLessCritical(const LogLevel *lvl) const {return m_lvl > lvl->number();}

        LogLevel() : m_lvl(Invalid) {}
    private:
        LogLevel(Number num, QColor col) : m_lvl(num), m_color(col) {}
        void setText(QString txt) {m_text = txt;}

        Number  m_lvl;
        QString m_text;
        QColor  m_color;


        friend class Log;
    };
}


#endif // LQMEAS_LOGLEVEL_H

