if(NOT LQMEAS_DIR)
    set(LQMEAS_DIR meas)
endif(NOT LQMEAS_DIR)

set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
    ${LQMEAS_DIR}/log/Log.cpp
    ${LQMEAS_DIR}/log/LogModel.cpp
    ${LQMEAS_DIR}/log/LogPanel.cpp

    ${LQMEAS_DIR}/devs/Device.cpp
    ${LQMEAS_DIR}/devs/resolver/DevicesResolver.cpp
    ${LQMEAS_DIR}/devs/resolver/DeviceNetworkBrowser.cpp

    ${LQMEAS_DIR}/ifaces/out/OutSignalFabric.cpp
    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignalSin.cpp
    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignalConst.cpp
    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignalPulse.cpp
    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignalRamp.cpp

    ${LQMEAS_DIR}/ifaces/out/DigSignals/DigSignalPulse.cpp

    ${LQMEAS_DIR}/ifaces/out/DevOut.cpp
    ${LQMEAS_DIR}/ifaces/out/DevOutStream.cpp
    ${LQMEAS_DIR}/ifaces/out/DevOutStreamThread.cpp

    ${LQMEAS_DIR}/ifaces/in/DevAdc.cpp
   )
   
set(LQMEAS_HEADERS ${LQMEAS_HEADERS}
    ${LQMEAS_DIR}/Error.h
    ${LQMEAS_DIR}/lqtdefs.h

    ${LQMEAS_DIR}/units/Unit.h

    ${LQMEAS_DIR}/log/LogLevel.h
    ${LQMEAS_DIR}/log/LogMessage.h


    ${LQMEAS_DIR}/devs/DeviceValidator.h


    ${LQMEAS_DIR}/devs/resolver/DevicesResolver.h
    ${LQMEAS_DIR}/devs/resolver/DevicesResolverIpAddr.h
    ${LQMEAS_DIR}/devs/resolver/DeviceSvcRecord.h
    ${LQMEAS_DIR}/devs/DeviceFrameReceiver.h
    ${LQMEAS_DIR}/devs/DeviceFrameSender.h


    ${LQMEAS_DIR}/ifaces/out/OutSignal.h

    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignal.h
    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignalSin.h
    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignalConst.h
    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignalPulse.h
    ${LQMEAS_DIR}/ifaces/out/DacSignals/DacSignalRamp.h

    ${LQMEAS_DIR}/ifaces/out/DigSignals/DigSignal.h
    ${LQMEAS_DIR}/ifaces/out/DigSignals/DigSignalPulse.h


    ${LQMEAS_DIR}/ifaces/out/DevOut.h
    ${LQMEAS_DIR}/ifaces/out/DevOutStream.h

    ${LQMEAS_DIR}/ifaces/in/DevAdc.h
   )
   
set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}
    ${LQMEAS_DIR}/StdErrors.h

    ${LQMEAS_DIR}/units/Units.h

    ${LQMEAS_DIR}/log/Log.h
    ${LQMEAS_DIR}/log/LogModel.h
    ${LQMEAS_DIR}/log/LogPanel.h


    ${LQMEAS_DIR}/devs/Device.h    
    ${LQMEAS_DIR}/devs/resolver/DeviceNetworkBrowser.h

    ${LQMEAS_DIR}/ifaces/out/OutSignalFabric.h
    ${LQMEAS_DIR}/ifaces/out/DevOutStreamThread.h
    )





set(LTR_MODULES LTR24 LTR25 LTR35 LTR51 LTR210)

foreach(LTR_MODULE ${LTR_MODULES})
    list(FIND LQMEAS_DEVS ${LTR_MODULE} ${LTR_MODULE}_IDX)
    if(NOT ${LTR_MODULE}_IDX EQUAL -1)
         string(TOLOWER ${LTR_MODULE} LTR_MODULE_LOWER)

        set(LQMEAS_DEV_${LTR_MODULE} ON)
        set(LQMEAS_DEV_LTR    ON)

        set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
            ${LQMEAS_DIR}/devs/ltr/modules/${LTR_MODULE_LOWER}.cpp)
        set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}
            ${LQMEAS_DIR}/devs/ltr/modules/${LTR_MODULE_LOWER}.h)
        set(LQMEAS_LIBS ${LQMEAS_LIBS} ${LTR_MODULE_LOWER}api)
    endif()
endforeach()

if(LQMEAS_DEV_LTR)  
    include_directories(${LTRAPI_INCLUDE_DIR})
    link_directories(${LTRAPI_LIBRARIES_DIR})
    add_definitions(-DLTRAPI_DISABLE_COMPAT_DEFS)
    set(LQMEAS_LIBS ${LQMEAS_LIBS} ltrapi)

    set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}
        ${LQMEAS_DIR}/devs/ltr/crates/LtrCrate.h
        ${LQMEAS_DIR}/devs/ltr/modules/LtrModule.h
    )

    set(LQMEAS_HEADERS ${LQMEAS_HEADERS}
        ${LQMEAS_DIR}/devs/ltr/LtrResolver.h
        ${LQMEAS_DIR}/devs/ltr/modules/LtrMezzanine.h
    )

    set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
        ${LQMEAS_DIR}/devs/ltr/LtrResolver.cpp

        ${LQMEAS_DIR}/devs/ltr/modules/LtrModule.cpp
        ${LQMEAS_DIR}/devs/ltr/crates/LtrCrate.cpp
    )   
endif(LQMEAS_DEV_LTR)



set(LCOMP_DEVICES E2010 E14_440)

foreach(LCOMP_DEVICE ${LCOMP_DEVICES})
    list(FIND LQMEAS_DEVS ${LCOMP_DEVICE} ${LCOMP_DEVICE}_IDX)
    if(NOT ${LCOMP_DEVICE}_IDX EQUAL -1)
        string(TOLOWER ${LCOMP_DEVICE} LCOMP_MODULE_LOWER)

        set(LQMEAS_DEV_${LCOMP_DEVICE}  ON)
        set(LQMEAS_DEV_LCOMP            ON)

        set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
            ${LQMEAS_DIR}/devs/lcomp/${LCOMP_MODULE_LOWER}.cpp)
        set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}
            ${LQMEAS_DIR}/devs/lcomp/${LCOMP_MODULE_LOWER}.h)
    endif()
endforeach()

if(LQMEAS_DEV_LCOMP)

    if(WIN32 AND NOT LCOMP_LIBRARY_ROOT_DIR)
        set(LCOMP_LIBRARY_ROOT_DIR "c:/Program Files (x86)/L-Card/LIBRARY")
    endif()
    include_directories(${LCOMP_LIBRARY_ROOT_DIR})

    set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}        
        ${LQMEAS_DIR}/devs/lcomp/lcompDevice.h
        ${LQMEAS_DIR}/devs/lcomp/lcompStreamDevice.h
        ${LQMEAS_DIR}/devs/lcomp/lcompStreamReceiver.h
    )

    set(LQMEAS_HEADERS ${LQMEAS_HEADERS}
        ${LQMEAS_DIR}/devs/lcomp/lcomp_headers.h
        ${LQMEAS_DIR}/devs/lcomp/lcompResolver.h
        ${LQMEAS_DIR}/devs/lcomp/lcompErrors.h
        ${LQMEAS_DIR}/devs/lcomp/lcompRecvProcessorIface.h
    )

    set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
        ${LQMEAS_DIR}/devs/lcomp/lcompResolver.cpp
        ${LQMEAS_DIR}/devs/lcomp/lcompDevice.cpp
        ${LQMEAS_DIR}/devs/lcomp/lcompStreamDevice.cpp
        ${LQMEAS_DIR}/devs/lcomp/lcompStreamReceiver.cpp
    )
endif(LQMEAS_DEV_LCOMP)



set(X502_DEVICES E502 L502)
foreach(X502_DEVICE ${X502_DEVICES})
    list(FIND LQMEAS_DEVS ${X502_DEVICE} ${X502_DEVICE}_IDX)
    if(NOT ${X502_DEVICE}_IDX EQUAL -1)
        string(TOLOWER ${X502_DEVICE} X502_DEVICE_LOWER)
        set(LQMEAS_DEV_${X502_DEVICE}  ON)
        set(LQMEAS_DEV_X502            ON)

        include_directories(${X502API_INCLUDE_DIR}/devs/${X502_DEVICE_LOWER})
        set(LQMEAS_LIBS ${LQMEAS_LIBS} ${X502_DEVICE_LOWER}api)

        set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}
            ${LQMEAS_DIR}/devs/x502/${X502_DEVICE_LOWER}.h
        )

        set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
            ${LQMEAS_DIR}/devs/x502/${X502_DEVICE_LOWER}.cpp
        )
    endif()
endforeach()


if(LQMEAS_DEV_X502)
    include_directories(${X502API_INCLUDE_DIR})
    link_directories(${X502API_LIBRARIES_DIR})

    set(LQMEAS_LIBS ${LQMEAS_LIBS} x502api)

    set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}
        ${LQMEAS_DIR}/devs/x502/x502.h
        ${LQMEAS_DIR}/devs/x502/e502NetBrowser.h
    )

    set(LQMEAS_HEADERS ${LQMEAS_HEADERS}
        ${LQMEAS_DIR}/devs/x502/x502Resolver.h
        ${LQMEAS_DIR}/devs/x502/e502SvcRecord.h
    )

    set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
        ${LQMEAS_DIR}/devs/x502/x502.cpp
        ${LQMEAS_DIR}/devs/x502/x502Resolver.cpp
        ${LQMEAS_DIR}/devs/x502/e502SvcRecord.cpp
        ${LQMEAS_DIR}/devs/x502/e502NetBrowser.cpp
    )
endif(LQMEAS_DEV_X502)



list(FIND LQMEAS_DEVS Agilent3458 Agilent3458_IDX)
if(NOT Agilent3458_IDX EQUAL -1)
    set(LQMEAS_DEV_AGILENT_3458  ON)

    include_directories(${AG3458API_INCLUDE_DIR})
    link_directories(${AG3458API_LIBRARIES_DIR})

    set(LQMEAS_LIBS ${LQMEAS_LIBS} Agilent3458api)

    set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}

        ${LQMEAS_DIR}/devs/gpib/gpibResolver.h
        ${LQMEAS_DIR}/devs/gpib/Agilent3458.h
    )
    set(LQMEAS_HEADERS ${LQMEAS_HEADERS}
    )

    set(LQMEAS_SOURCES ${LQMEAS_SOURCES}

        ${LQMEAS_DIR}/devs/gpib/gpibResolver.cpp
        ${LQMEAS_DIR}/devs/gpib/Agilent3458.cpp
    )

endif()


if(LQMEAS_GUI_LTR_MODULE_SELECTION)
    set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
        ${LQMEAS_DIR}/gui/LtrModuleSelection/LtrModuleSelection.cpp)
    set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}
        ${LQMEAS_DIR}/gui/LtrModuleSelection/LtrModuleSelection.h)
endif(LQMEAS_GUI_LTR_MODULE_SELECTION)

if(LQMEAS_SERVICE_MULTIMETER_THREAD)
    set(LQMEAS_USE_LMATH ON)
    set(LQMEAS_SOURCES ${LQMEAS_SOURCES}
        ${LQMEAS_DIR}/services/MultimeterThread/MultimeterThread.cpp
        ${LQMEAS_DIR}/services/MultimeterThread/MultimeterProcessor.cpp)
    set(LQMEAS_QT_HEADERS ${LQMEAS_QT_HEADERS}
        ${LQMEAS_DIR}/services/MultimeterThread/MultimeterThread.h
        ${LQMEAS_DIR}/services/MultimeterThread/MultimeterProcessor.h)
endif(LQMEAS_SERVICE_MULTIMETER_THREAD)

if(LQMEAS_USE_LMATH)
    include_directories(${LMATH_INCLUDE_DIR})
     link_directories(${LMATH_LIBRARIES_DIR})

    set(LQMEAS_LIBS ${LQMEAS_LIBS} lmath)
endif(LQMEAS_USE_LMATH)


configure_file(${LQMEAS_DIR}/lqmeas_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/lqmeas_config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})


set(LQMEAS_TS_BASENAME lqmeas)

#обработка файлов переводов
set(LQMEAS_LANGUAGE_TS_FILES)
foreach(LANGUAGE ${LANGUAGES})
    set(LQMEAS_TS_FILE "${LQMEAS_DIR}/${LQMEAS_TS_BASENAME}_${LANGUAGE}.ts")
    set_source_files_properties(${LQMEAS_TS_FILE} PROPERTIES OUTPUT_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/translations)
    set(LQMEAS_LANGUAGE_TS_FILES ${LQMEAS_LANGUAGE_TS_FILES} ${LQMEAS_TS_FILE})
endforeach(LANGUAGE ${LANGUAGES})

if(LQMEAS_BUILD_WITH_QT5)
    qt5_wrap_cpp(LQMEAS_MOC_SOURCES  ${LQMEAS_QT_HEADERS})
    qt5_wrap_ui(LQMEAS_QT_UI_HEADERS ${LQMEAS_QT_UI_FILES})

    if(LQMEAS_CREATE_TRANSLATION)
        qt5_create_translation(LQMEAS_QM_FILES ${LQMEAS_QT_UI_HEADERS} ${LQMEAS_LANGUAGE_TS_FILES}
                            ${LQMEAS_QT_HEADERS} ${LQMEAS_HEADERS} ${LQMEAS_SOURCES} ${LQMEAS_MOC_SOURCES})
    else(LQMEAS_CREATE_TRANSLATION)
        qt5_add_translation(LQMEAS_QM_FILES ${LQMEAS_LANGUAGE_TS_FILES})
    endif(LQMEAS_CREATE_TRANSLATION)
else(LQMEAS_BUILD_WITH_QT5)
    qt4_wrap_cpp(LQMEAS_MOC_SOURCES  ${LQMEAS_QT_HEADERS})
    qt4_wrap_ui(LQMEAS_QT_UI_HEADERS ${LQMEAS_QT_UI_FILES})

    if(LQMEAS_CREATE_TRANSLATION)
        qt4_create_translation(LQMEAS_QM_FILES ${LQMEAS_QT_UI_HEADERS} ${LQMEAS_LANGUAGE_TS_FILES}
                            ${LQMEAS_QT_HEADERS} ${LQMEAS_HEADERS} ${LQMEAS_SOURCES} ${LQMEAS_MOC_SOURCES})
    else(LQMEAS_CREATE_TRANSLATION)
        qt4_add_translation(LQMEAS_QM_FILES ${LQMEAS_LANGUAGE_TS_FILES})
    endif(LQMEAS_CREATE_TRANSLATION)
endif(LQMEAS_BUILD_WITH_QT5)


set(LQMEAS_FILES  ${LQMEAS_SOURCES} ${LQMEAS_QT_HEADERS} ${LQMEAS_HEADERS}
                   ${LQMEAS_QT_UI_FILES} ${LQMEAS_MOC_SOURCES} ${LQMEAS_QT_UI_HEADERS}
                   ${LQMEAS_QM_FILES})

