#ifndef STDUNITS
#define STDUNITS

#include "Unit.h"
#include <QObject>

namespace LQMeas {
    class Units : public QObject {
        Q_OBJECT
    public:
        static Unit V() {return Unit(tr("V"), 1);}
        static Unit mV() {return Unit(tr("mV"), 0.001);}

        static Unit Hz() {return Unit(tr("Hz"), 1);}
        static Unit KHz() {return Unit(tr("KHz"), 1000);}
        static Unit MHz() {return Unit(tr("MHz"), 1000000);}

        static Unit s() {return Unit(tr("s"), 1);}
        static Unit ms() {return Unit(tr("ms"), 0.001);}
        static Unit mks() {return Unit(tr("µS"), 0.00001);}

        static Unit degree() {return Unit(tr("°"));}

        static Unit percentage() {return Unit(tr("%"));}
    };
}

#endif // STDUNITS

