#ifndef FREQCONFIGWIDGET_H
#define FREQCONFIGWIDGET_H

#include <QWidget>
#include <QSettings>
class QDoubleSpinBox;
class QComboBox;

class FreqConfigWidget : public QWidget {
    Q_OBJECT
public:
    explicit FreqConfigWidget(QWidget *parent = 0);

    int unitMultCoef() const;
    double value() const {return m_val;}

    void loadUnitSettings(QSettings &set, QString key);
    void saveUnitSettings(QSettings &set, QString key);
signals:
    void editingFinished();
    void unitChanged(int mult);
public slots:
    void setValue(double val);
    void setReadOnly(bool readOnly);
    void setMaximum(double max);
    void setMinimum(double min);
    void setUnitReadOnly(bool readOnly);
    void setUnitMultCoef(int mult);

private slots:
    void onUnitChanged(int idx);
    void onValueChanged(double val);

private:
    QDoubleSpinBox *m_freqEdit;
    QComboBox *m_unitBox;
    double m_val, m_max, m_min;
};

#endif // FREQCONFIGWIDGET_H
