#ifndef CONFIGDIALOGX502_H
#define CONFIGDIALOGX502_H

#include <QDialog>

#include "lqmeas/devs/x502/x502.h"

namespace Ui {
class X502ConfigDialog;
}


class QTableWidgetItem;
class QComboBox;
class QSpinBox;

class X502ConfigDialog : public QDialog {
    Q_OBJECT

public:
    explicit X502ConfigDialog(QSharedPointer<LQMeas::X502> dev, QWidget *parent = 0);
    ~X502ConfigDialog();
public slots:
    void accept();
private slots:
    LQMeas::Error setConfig();
    void adcMaxInChFreqChanged(int);
    void chModeChanged();
    void updateCommChState(int i);
    void cellDataChanged(int row, int col);
    void setMaxAdcFreq();
    void setMaxAdcChFreq();
    void addOption(QString text, bool val);
private:
    Ui::X502ConfigDialog *ui;

    void setComboBoxItemByData(QComboBox *box, int data);
    void fillSyncBox(QComboBox *box, int value);


    struct ChUi {
        QTableWidgetItem *chItem;
        QComboBox *mode;
        QComboBox *range;
        QSpinBox  *avg;
    };


    QSharedPointer<LQMeas::X502> m_dev;
    QList<ChUi> m_chUis;

};

#endif // CONFIGDIALOGX502
