#ifndef DACSIGNALDIALOG_H
#define DACSIGNALDIALOG_H

#include <QDialog>

#include "lqmeas/ifaces/out/DacSignals/DacSignal.h"

namespace Ui {
class DacSignalDialog;
}
namespace LQMeas {
    class DevOut;
}

class DacSignalParamUi;


class DacSignalDialog : public QDialog {
    Q_OBJECT

public:
    explicit DacSignalDialog(QWidget *parent, LQMeas::DevOut *dac, int ch,
                             QSharedPointer<LQMeas::DacSignal> signal);
    ~DacSignalDialog();

    QSharedPointer<LQMeas::DacSignal> getSignal();
private slots:
    void setUiByIdx(int idx);
private:
    void removeRow(int row);

    int m_const_item_cnt;
    Ui::DacSignalDialog *ui;
    QList<DacSignalParamUi*> m_sigUi;
    LQMeas::DevOut *m_dac;
    int m_ch;
    DacSignalParamUi *m_curSigUi;
    QSharedPointer<LQMeas::DacSignal>  m_curSignal;

};

#endif // DACSIGNALDIALOG_H
