#ifndef OUTSIGGENARATION_H
#define OUTSIGGENARATION_H

#include "ProcessPlugin.h"

#include "lqmeas/ifaces/out/DevOutStream.h"
#include "lqmeas/devs/Device.h"

namespace LQMeasStudio {
    class OutSigGenaration : public ProcessPlugin {
        Q_OBJECT
    public:
        static QString typePluginName() {return "OutSigGenaration";}
        OutSigGenaration() : ProcessPlugin(typePluginName()) {}

        void procStartPrepare();
        void procStart();
        void procStop();
        void procClear();

        int runningDevs();



    signals:
        void deviceError(QSharedPointer<LQMeas::Device> dev, LQMeas::Error err, QString caption, QString msg);        

    private slots:

        void onThreadFinished();        
        void sendError(LQMeas::DevOut *outDev, LQMeas::Error err);
    private:

        QList<LQMeas::DevOutStream *> m_outStreamDevs;
        QList<LQMeas::DevOut *> m_outCycleDevs;
        QList<QSharedPointer<LQMeas::Device> > m_devs;


    };
}

#endif // OUTSIGGENARATION_H
